// ******************************************************************************
// Copyright (c) 2007 srcX Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
// ******************************************************************************

#ifndef CSRCXPLUGIN_H
#define CSRCXPLUGIN_H

#define SRCX_VERSION "0.1.1"

#include "engine/iserverplugin.h"
#include "igameevents.h"
#include "interface.h"

class CsrcXPlugin: public IServerPluginCallbacks, public IGameEventListener2
{
public:
	CsrcXPlugin();
	~CsrcXPlugin() {}

	// IServerPluginCallbacks methods.
	virtual bool Load(CreateInterfaceFn interfaceFactory, CreateInterfaceFn gameServerFactory);
	virtual void Unload();
	virtual void Pause();
	virtual void UnPause();
	virtual const char* GetPluginDescription();
	virtual void LevelInit(char const* pszMapName);
	virtual void ServerActivate(edict_t* pEdictList, int nEdictCount, int nClientMax);
	virtual void GameFrame(bool bSimulating);
	virtual void LevelShutdown();
	virtual void ClientActive(edict_t* pEdict);
	virtual void ClientDisconnect(edict_t* pEdict);
	virtual void ClientPutInServer(edict_t* pEdict, char const* pszClientName);
	virtual void SetCommandClient(int nIndex);
	virtual void ClientSettingsChanged(edict_t* pEdict);
	virtual PLUGIN_RESULT ClientConnect(bool* pbAllowConnect, edict_t* pEdict, const char* pszClientName, const char *pszAddress, char* pszReject, int nMaxRejectLen);
	virtual PLUGIN_RESULT ClientCommand(edict_t* pEdict);
	virtual PLUGIN_RESULT NetworkIDValidated(const char* pszClientName, const char* pszNetworkID);

	// IGameEventListener2 methods.
	virtual void FireGameEvent(IGameEvent* pGameEvent);

	// CsrcXPlugin methods.
	virtual int GetCommandIndex() const { return _nClientCommandIndex; }

private:
	int _nClientCommandIndex;
};

#endif // CSRCXPLUGIN_H
